package psw2.JIM;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;



public class JIMApplet extends Applet implements ActionListener,Runnable {
  Thread MachineRunner;  //a seperate Thread for calculating the behaviour of the components    
  
  final static String DEFAULT_STATUS      = "JIM - a Java Incredible Machine";                          
  final static String RUBBER_BAND_STATUS_1= "can connect two components";
  final static String RUBBER_BAND_STATUS_2= "select component you want to connect to";
  final static String MOUSE_CAGE_STATUS   = "if it is hit by another Component, mouse starts to run";
  final static String LENS_STATUS         = "can intensify a light source";
  final static String FLASH_LIGHT_STATUS  = "a light source";
  final static String CANNON_STATUS       = "light the fuse and it fires";
  final static String COMPONENT_STATUS    = "can be placed on the map ";
      
  final static String LOADMAPBUTTON = "load map";
  final static String STARTBUTTON = "start JIM";
  final static String RESETBUTTON = "reset JIM";   
  String mapDesc="";
    
  int traceX, traceY;   //mouse-coordinates
    
  boolean isRunning= false;  //determines whether machine is currently running or not
  boolean needtoken=true;
  boolean modalTrace= false;

  KeyAdapter componentkeylistener;  
  JIMFactory factory;     //to generate JIMMComponents and add the to the mapContainer    
  JIMMComponent tempRotatable= null;  //auxiliary variable        
  java.awt.List itemList; //the list of Components to insert
  java.util.Vector jcList;    //the list of Components on the Panel

  PipedInputStream levelloader=null;
  
  //JIMImageMapEntries indexed by a filename for an Image
  //these are the Images requested by JIMMComponents
  java.util.Dictionary ImageMap=new java.util.Hashtable();  
  
  Container mapContainer; //the Container we put the JIMMComponents in
  Panel eastPanel;
  Label statusLabel;

  
  public void init()  {
    setEnabled(false);
    if (getParameter("BGCOLOR")!=null)
      setBackground(new Color(Integer.parseInt(getParameter("BGCOLOR"),16)));
    else
      setBackground(new Color(241,201,37));

    componentkeylistener=new KeyAdapter() {
      public void keyPressed(KeyEvent e) {
        if ((e.getKeyCode()==KeyEvent.VK_DELETE) && (!((JIMMComponent)e.getSource()).isLocked)) {
          factory.removeComponent((JIMMComponent)e.getSource());                    
          transferFocus();
        }
      }
    };
    
    factory=new JIMFactory(this);
    //Panel eastPanel = new Panel();
    eastPanel = new Panel();
    Panel buttonPanel = new Panel();

    //Buttons
    Button startButton= new Button(STARTBUTTON);
    Button loadButton= new Button(LOADMAPBUTTON);
    Button resetButton= new Button(RESETBUTTON);

    startButton.addActionListener(this);
    loadButton.addActionListener(this);
    resetButton.addActionListener(this);

    buttonPanel.add(loadButton);
    buttonPanel.add(startButton);
    buttonPanel.add(resetButton);

    buttonPanel.setLayout(new GridLayout(3,1));

    itemList= new java.awt.List();
    itemList.setSize(new Dimension(214,270));

    eastPanel.setLayout(new BorderLayout());
    eastPanel.add(buttonPanel, BorderLayout.NORTH);
    eastPanel.add(itemList, BorderLayout.CENTER);
    
    setLayout(new BorderLayout());
    add(eastPanel, BorderLayout.EAST);   

    mapContainer=new JIMDblBufferedContainer();
    mapContainer.setLayout(null);
    mapContainer.addMouseListener(new MouseAdapter(){
      public void mouseClicked(java.awt.event.MouseEvent event){
        if ((!isRunning) && (itemList.getSelectedItem()!=null)) {
          if ((!itemList.getSelectedItem().equals("RubberBand"))&&
            (factory.createJIMMComponent(itemList.getSelectedItem(), event.getX(), event.getY()) != null)) {
            itemList.remove(itemList.getSelectedItem());
	    repaint();
          };
        }
        if (modalTrace)
        {	modalTrace=false;
        	repaint();
        }
      }
    });          
        
    mapContainer.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(java.awt.event.MouseEvent event) {        
        Applet_mouseMoved(event);                       
      };
    });

    add(mapContainer, BorderLayout.CENTER);
    
    itemList.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        String item= itemList.getSelectedItem().toString();
        StringBuffer status= new StringBuffer(item);
        
        if (item.equals("RubberBand"))
          status.append(": " + RUBBER_BAND_STATUS_1);
        else if (item.equals("MouseCage"))
          status.append(": " + MOUSE_CAGE_STATUS);
        else if (item.equals("Lens"))
          status.append(": " + LENS_STATUS);
        else if (item.equals("FlashLight"))
          status.append(": " + FLASH_LIGHT_STATUS);
        else if (item.equals("Cannon"))
          status.append(": " + CANNON_STATUS);
        else
          status.append(": " + COMPONENT_STATUS);
        
        setStatusText(status.toString());
      };
    });
        
        
    //add statusPanel at bottom of applet
    statusLabel= new Label(DEFAULT_STATUS);
    statusLabel.setBackground(Color.white);        
    add(statusLabel, BorderLayout.SOUTH);                
        
    validate();   
  };      





  //actionhandlers for the 3 Buttons
  public void actionPerformed(ActionEvent event){
    String cmd= event.getActionCommand();
    if(cmd.equals(LOADMAPBUTTON)){
      loadMap();
    }
    else if(cmd.equals(STARTBUTTON)) {
      startmachine();
    }
    else if(cmd.equals(RESETBUTTON)) {
      resetmachine();
    }
  }



  //opens a Filedialog to specify a map to be loaded
  public void loadMap() {loadMap("");}
    
  //open the file specified by filename, or if filename equals ""
  //opens a Filedialog to specify a file to be loaded
  public void loadMap(String filename) {
    FileDialog fd;
    String dirname="psw2"+File.separator+"JIM"+File.separator+"maps"+File.separator;
    resetmachine();
    if (filename.equals("")){
      fd=new FileDialog(new Frame());
      fd.setMode(FileDialog.LOAD);
      fd.setDirectory(dirname);
      fd.setVisible(true);
      filename=fd.getFile();
      dirname=fd.getDirectory();
    }
    if (filename!=null){
      try{

        FileInputStream fileIS=new FileInputStream(dirname+filename);
        loadMap(fileIS);
        waitForImages();
        setEnabled(true);
      }catch(Exception e){
        e.printStackTrace();
        jcList=new java.util.Vector();
      }
    }
    mapContainer.repaint();
  }
    
  public void loadMap(InputStream input)
  {
    boolean levelOK=false;
    try{
      DataInputStream dataIS = new DataInputStream(input);
      Point point= new Point();
      String args;
      jcList= new java.util.Vector();
      itemList.removeAll();
      mapContainer.removeAll();
      for(int i = dataIS.readInt(); i>0; i--) {
        point.x=dataIS.readInt();
        point.y=dataIS.readInt();
        args=dataIS.readUTF();
        factory.createJIMMComponent(args, point.x, point.y,false);
      }
      for(int i = dataIS.readInt(); i>0; i--)
        itemList.add(dataIS.readUTF());

      mapDesc=DEFAULT_STATUS;
      levelOK=true; //Level loaded, just auxiliary stuff to load
                    //no problem if a failure occurs there
      
      mapDesc=dataIS.readUTF();
      setStatusText(mapDesc);
            
      dataIS.close();    
    }catch(Exception e){
      if (!levelOK)
      {
      	e.printStackTrace();
        jcList=new java.util.Vector();
      }
    }
  };
    
  public void saveMap(OutputStream output)
  {
    try{
      DataOutputStream dataOS = new DataOutputStream(output);
      String str;
      int size=jcList.size();
      JIMMComponent comp= null;
      dataOS.writeInt(size);
      for(int i=0; i<size; i++) {
        comp=(JIMMComponent)jcList.elementAt(i);
        dataOS.writeInt(comp.getLocation().x);
        dataOS.writeInt(comp.getLocation().y);
        dataOS.writeUTF(comp.toString());         
      }
      size=itemList.getItemCount();
      dataOS.writeInt(size);
      for(int i=0; i<size; i++) {
        dataOS.writeUTF(itemList.getItem(i));
      }
      dataOS.writeUTF(mapDesc);

    }catch(Exception e){
      System.err.println(e.toString() + " at saveMap: ");      
    }
  }
    

  //just load a default map on startup
  public void start() {
    loadMap("start.map");                   
  };






  //now on to the machine itself



  //prepare to get the machine running    
  public void startmachine() {      
    if (MachineRunner==null)
    {
      MachineRunner = new Thread(this);
      isRunning=true;                     
      JIMMComponent icomp;
        
      try{
        PipedOutputStream levelsaver=new PipedOutputStream();
        levelloader=new PipedInputStream(levelsaver);
        saveMap(levelsaver);
      }catch(Exception e){levelloader=null;}
      
      for (int i=0;i<jcList.size();i++)
      {
        icomp=((JIMMComponent)jcList.elementAt(i));
        icomp.fpax=icomp.getLocation().x<<4;
        icomp.fpay=icomp.getLocation().y<<4;                
        if (icomp instanceof JIMCGearWheel) autoLink(icomp);
        icomp.startMachine();
        icomp.setVisible(false);
      }       

      MachineRunner.start();
    }

  }




  //when the user hits the "reset JIM" Button, everything should be reset
  //to the situation before the machine was started
  public void resetmachine()
  {
    MachineRunner = null;
    if (isRunning)
    {      	
      isRunning=false;
      if (levelloader!=null)
      {
        try{
          loadMap(levelloader);
          levelloader=null;
        }catch(Exception e){loadMap("start");}
      }      
      mapContainer.repaint();
    }       
    repaint();
  }

    
    
    
    
  //gets the Collisions between this two very JIMMComponents
  //ret[0] is a Vector containing Vertex-start-node-indices
  //ret[1] is a Vector containing Vertex-start-node-indices
  //ret[2] is the JIMMComponent of ret[1]
  public Object[] getCollision(JIMMComponent comp, JIMMComponent altcomp)
  {
    Object[] result=null;
    JIMPolygon altpoly;
  
    if ((altcomp.getBounds().intersects(comp.getBounds())) && (altcomp.poly!=null) && (comp.poly!=null))
    {
      altpoly=new JIMPolygon(altcomp.poly);
      altpoly.translate((altcomp.fpax-comp.fpax)>>4,(altcomp.fpay-comp.fpay)>>4);

      result=comp.poly.intersects(altpoly);
    
      if (result==null)
      {
        //so no collision, but still to check
        //if comp is completely in altcomp or vice-versa
        if ( (comp.poly.dist(altpoly.xpoints[0],altpoly.ypoints[0])<0)
           ||(altpoly.dist(comp.poly.xpoints[0],comp.poly.ypoints[0])<0)  )
          result=new Object[]{new java.util.Vector(),new java.util.Vector(),null};
      
      }
      if (result!=null) result[2]=altcomp;
    }

    return result;
  }



  //Collision-information for first of all JIMMComponents, which
  //are colliding with comp
  //ret[0] is a Vector containing Vertex-start-node-indices
  //ret[1] is a Vector containing Vertex-start-node-indices
  //ret[2] is the JIMMComponent of ret[1]
  public Object[] getCollisions(JIMMComponent comp)
  {
    JIMMComponent altcomp=null;
    Object[] result=null;
    int i;
    for (i=0;(result==null) && (i<jcList.size());i++)
    {
      altcomp=((JIMMComponent)jcList.elementAt(i));
      if (altcomp!=comp)
      {
        result=getCollision(comp, altcomp);
      }       
    }
    return result;
  }




  //resolves the Collisions of comp
  //returns true if there was at least a single collision to be resolved
  //a return value true, does not imply, that comp is not colliding with
  //any JIMMComponents any longer. Only successive calls, till false is
  //returned grant this.
  public boolean resolveCollisions(JIMMComponent comp)
  {
    int i;
    Object cols[],oldcols[];
    JIMMComponent altcomp,fastcomp,slowcomp;
    int stilltomove;
    double mirrorx,mirrory;
    int vectx,vecty;
    int origcompfpax,origcompfpay;
    int origaltcompfpax,origaltcompfpay;
    boolean didcollide=false;
      
    if (((cols=getCollisions(comp))!=null)  )// && ((comp.vx!=0) || (comp.vy!=0)))
    {
      didcollide=true;
      altcomp=(JIMMComponent)cols[2];

      origcompfpax=comp.fpax;
      origcompfpay=comp.fpay;
      origaltcompfpax=altcomp.fpax;
      origaltcompfpay=altcomp.fpay;
      
      stilltomove=0;
      oldcols=null;
      while (cols!=null) //intersection, so try to seperate them
      {
        oldcols=cols;
        stilltomove++;
        altcomp.fpamoveto(origaltcompfpax-((stilltomove*altcomp.vx)>>3),origaltcompfpay-((stilltomove*altcomp.vy)>>3));
        comp.fpamoveto(origcompfpax-((stilltomove*comp.vx)>>3),origcompfpay-((stilltomove*comp.vy)>>3));
        cols=getCollision(comp,altcomp);
      }
      
      cols=oldcols; //so we actually have the collision, which last occured.

      if (cols!=null)
      {
        java.util.Vector compList,altcompList;
        JIMPolygon compPolygon,altcompPolygon;
        int compidx,altcompidx;
        double complen,altcomplen,len;
        int compvectx,compvecty;
        int altcompvectx,altcompvecty;
         
        compList   =(java.util.Vector)cols[0];
        altcompList=(java.util.Vector)cols[1];
        compPolygon=comp.poly;
        altcompPolygon=altcomp.poly;
          
        mirrorx=mirrory=0;
        for (i=0;i<compList.size();i++)
        {
          compidx=((Integer)(compList.elementAt(i))).intValue();
          altcompidx=((Integer)(altcompList.elementAt(i))).intValue();
                    
          compvectx=compPolygon.xpoints[compidx+1]-compPolygon.xpoints[compidx];
          compvecty=compPolygon.ypoints[compidx+1]-compPolygon.ypoints[compidx];
          complen=compvectx*compvectx+compvecty*compvecty;
          altcompvectx=altcompPolygon.xpoints[altcompidx+1]-altcompPolygon.xpoints[altcompidx];
          altcompvecty=altcompPolygon.ypoints[altcompidx+1]-altcompPolygon.ypoints[altcompidx];
          altcomplen=altcompvectx*altcompvectx+altcompvecty*altcompvecty;
          if ((complen>0) && (altcomplen>0))
          {
            complen=(16/(Math.sqrt(complen)));
            altcomplen=(16/(Math.sqrt(altcomplen)));              
            compvectx*=-complen;   //so the normal vector points to INSIDE!           
            compvecty*=-complen;              
            altcompvectx*=altcomplen; //and this one outside
            altcompvecty*=altcomplen;             
            mirrorx+=compvecty+altcompvecty;
            mirrory-=compvectx+altcompvectx;
          }   
            
        }         
      
        len=mirrorx*mirrorx+mirrory*mirrory;
        if (len>0)
        {
          len=1/Math.sqrt(len);
          mirrorx*=len;
          mirrory*=len;
        }
        else
        {
          mirrorx=1;
          mirrory=0;
          System.err.println("COLLISION:Mirrorlen=0 [assuming (1,0)]");
        }
        double compproj,altcompproj,compmirrfact,altcompmirrfact;
          
        compproj=(comp.vx*mirrorx+comp.vy*mirrory);//projection of velocity vertex onto the reflection direction
        altcompproj=(altcomp.vx*mirrorx+altcomp.vy*mirrory);//mirror is already unity vector
      
        if (comp.isFixed)
        { altcompmirrfact=(-comp.rebFact*altcomp.rebFact-1)*altcompproj;
          compmirrfact=0;
        } 
        else 
        if (altcomp.isFixed) {
          compmirrfact=(-comp.rebFact*altcomp.rebFact-1)*compproj;
          altcompmirrfact=0;
        }
        else 
        { compmirrfact=(compproj*(comp.weight-altcomp.weight) + altcomp.weight*altcompproj*(1+comp.rebFact*altcomp.rebFact))/(comp.weight+altcomp.weight)-compproj;
          altcompmirrfact=(altcompproj*(altcomp.weight-comp.weight) + comp.weight*compproj*(1+comp.rebFact*altcomp.rebFact))/(comp.weight+altcomp.weight)-altcompproj;
        }
    
        comp.vx+=(int)(mirrorx*compmirrfact);
        comp.vy+=(int)(mirrory*compmirrfact);
        altcomp.vx+=(int)(mirrorx*altcompmirrfact);
        altcomp.vy+=(int)(mirrory*altcompmirrfact);

        origcompfpax=comp.fpax;
        origcompfpay=comp.fpay;
        origaltcompfpax=altcomp.fpax;
        origaltcompfpay=altcomp.fpay;

        //inform the components about the collisions
        for (i=0;i<compList.size();i++)
        {
          compidx=((Integer)(compList.elementAt(i))).intValue();
          altcompidx=((Integer)(altcompList.elementAt(i))).intValue();
          comp.onCollision(compidx,altcompidx,altcomp);
          altcomp.onCollision(altcompidx,compidx,comp);
        }
    
      
        while ((cols!=null)||(getCollision(altcomp,comp)!=null))
        {
          altcomp.fpamoveto(origaltcompfpax+((stilltomove*altcomp.vx)>>3),origaltcompfpay+((stilltomove*altcomp.vy)>>3));
          comp.fpamoveto(origcompfpax+((stilltomove*comp.vx)>>3),origcompfpay+((stilltomove*comp.vy)>>3));
          cols=getCollision(comp,altcomp);
          stilltomove++;
        }
            
      }else
        System.err.println("COLLISION: THOUGHT THERE WAS ONE ... BUT ITS GONE");
    }
    return didcollide;  
  }
        
  private void machineRunPrepare()
  {
    int i;
    JIMMComponent icomp;
    //preperations and moving for every JIMMComponent 
    for (i=0;i<jcList.size();i++)
    {  
      icomp=((JIMMComponent)jcList.elementAt(i)); //grab element
      icomp.newMachineTurn();                     //notification of new machine turn
      icomp.vy+=1-icomp.lift;                     //gravitation
      icomp.fpamove();                            //finally moving
    }
    mapContainer.setLocation(0,0);
  }

  private void machineRunCollide()
  {
    boolean didcollide;
    int i;
    JIMMComponent icomp;
      

    //assume there have been collisions
    didcollide=true;
    while (didcollide)  //as long as there have been collisions ... resolve them
    {
      didcollide=false;
      for (i=0;i<jcList.size();i++)
      {
        didcollide=(didcollide||resolveCollisions((JIMMComponent)jcList.elementAt(i)));
      }
    }   
            
 
    //after moving and resolving collisions
    //write back the positions from our fixed point algorithm values
    //to int values
    //NOTE: in next term we continue calculation based on FPA values (because of higher signification       
    for (i=0;i<jcList.size();i++)
    {
      icomp=((JIMMComponent)jcList.elementAt(i));
      icomp.setLocation(icomp.fpax>>4,icomp.fpay>>4);
    } 
  }

  private void machineRunShedLight()
  {
    int i,shedderIdx,j,sensorIdx;
    JIMPolygon shedPoly=null;;
    JIMMComponent icomp,jcomp;
    java.util.Vector sensorList;
    JIMPropertyPoint ppt;
    
    //delete old lights
    for (i=0;i<jcList.size();i++)
    {  icomp=((JIMMComponent)jcList.elementAt(i));
       for (j=0;j<icomp.lightSensorList.size();j++)
       {
         ppt=(JIMPropertyPoint)icomp.lightSensorList.elementAt(j);
         ppt.property=0;
       }
    }

    //calc new lights    
    for (i=0;i<jcList.size();i++)
    {
      icomp=((JIMMComponent)jcList.elementAt(i));
      
      for (shedderIdx=0;shedderIdx<icomp.lightShedderList.size();shedderIdx++)
      {
        shedPoly=(JIMPolygon)icomp.lightShedderList.elementAt(shedderIdx);
        for (j=0;j<jcList.size();j++)
        {
          jcomp=(JIMMComponent)jcList.elementAt(j);
          sensorList=jcomp.lightSensorList;
          for (sensorIdx=0;sensorIdx<sensorList.size();sensorIdx++)
          {
            ppt=(JIMPropertyPoint)sensorList.elementAt(sensorIdx);
                
            if (shedPoly.dist(ppt.x+jcomp.getLocation().x-icomp.getLocation().x,ppt.y+jcomp.getLocation().y-icomp.getLocation().y)<=0)
                ppt.property++;               
          }                           
        }
      }         
    }       
  }

  private void machineRunShedHeat()
  {
    int i,shedderIdx,j,sensorIdx;
    JIMPolygon shedPoly=null;;
    JIMMComponent icomp,jcomp;
    java.util.Vector sensorList;
    JIMPropertyPoint ppt;
    
    //no cooling! (so every component has to cool itself)
    
    //but adding new heat    
    for (i=0;i<jcList.size();i++)
    {
      icomp=((JIMMComponent)jcList.elementAt(i));
      for (shedderIdx=0;shedderIdx<icomp.heatShedderList.size();shedderIdx++)
      {
        shedPoly=(JIMPolygon)icomp.heatShedderList.elementAt(shedderIdx);
        for (j=0;j<jcList.size();j++)
        {
          jcomp=(JIMMComponent)jcList.elementAt(j);
          sensorList=jcomp.heatSensorList;
          for (sensorIdx=0;sensorIdx<sensorList.size();sensorIdx++)
          {
            ppt=(JIMPropertyPoint)sensorList.elementAt(sensorIdx);
                
            if (shedPoly.dist(ppt.x+jcomp.getLocation().x-icomp.getLocation().x,ppt.y+jcomp.getLocation().y-icomp.getLocation().y)<=0)
              ppt.property++;               
          }                           
        }
      }         
    }       
  }

        
  //here the Machines next turn is calculated and drawn
  public void run() {
    Thread me = Thread.currentThread();

    while (   ((MachineRunner == me) && (isRunning))  )
    {
      machineRunPrepare();    
      machineRunCollide();    
      machineRunShedLight();    
      machineRunShedHeat();    
            
      //finally redraw the mapContainer, to make every movement, ... visible to the user
      mapContainer.repaint();
            
      try{Thread.sleep(10);}catch(java.lang.Exception e){}
        
    }
    MachineRunner=null;
  }









  //some functions for the JIMMComponents, to enable them to load Images with ease   
    
    
    
    
    
  //loads the images for the class specified by name (e.g.: "class psw2.JIM.JIMCTrampoline")
  //and returns an Image-array with 16 entries, each either null or the desired Image
  public Image[] getImagesForClass(String name) {
    Image[] ret=null;;
    File dir= new File("psw2"+File.separator+"JIM"+File.separator+"pics");
    if(dir.isDirectory()) {
      String[] files= dir.list();        
      String curStr= null;
      ret=new Image[16];

      name=name.substring(15, name.length());
      if (files!=null)
        for(int i=0; i<files.length; i++){
          curStr=files[i];
          if ((curStr.startsWith(name)) && (curStr.endsWith(".gif")) && (curStr.length()==name.length()+1+4))
              ret[Character.digit(curStr.charAt(name.length()),16)]=getImage(curStr);          
      }
    }else
      System.err.println("Directory "+dir.getName()+" does not exist");
    return ret;
    
  }
    
  //loads the images for the class specified by cls
  //and returns an Image-array with 16 entries, each either null or the desired Image
  public Image[] getImagesForClass(Class cls) {
    return getImagesForClass(cls.toString());
  }

  //loads the images for the class specified by the dynamic type of obj
  //and returns an Image-array with 16 entries, each either null or the desired Image
  public Image[] getImagesForClass(Object obj) {
    Image ret[]=getImagesForClass(obj.getClass().toString());
    return ret;
  }
   
    
    
  //loads the images for the class specified by name (e.g.: "class psw2.JIM.JIMCTrampoline")
  public void loadImagesForClass(String name) {
    getImagesForClass(name);
  }

  //loads the images for the class specified by cls
  public void loadImagesForClass(Class cls) {
    loadImagesForClass(cls.toString());
  }

  //loads the images for the class specified by the dynamic type of obj
  public void loadImagesForClass(Object obj) {
    loadImagesForClass(obj.getClass().toString());
  }
        
  //JIMMComponents should use getImage(String name) to load images
  //it assures, that these images are loaded before the Components
  //are drawn for the first time.
  public Image getImage(String name) {
    Image img=null;
      
    //assume the Image specified by name has already been loaded
    img=(Image)ImageMap.get(name);
      
    if (img==null) //so the assumption was wrong, better load it
    { img=super.getImage(getCodeBase(),"psw2"+File.separator+"JIM"+File.separator+"pics"+File.separator+name);
      ImageMap.put(name,img);
    }
    return img;       
  }
    
   
  //wait till all via getImage(String name) aquired Images are fully loaded
  public void waitForImages()
  {
    MediaTracker mt=new MediaTracker(this);
    Graphics g;
    java.util.Enumeration enum;


    enum=ImageMap.elements();       
    while (enum.hasMoreElements())
        mt.addImage((Image)enum.nextElement(),0);       

    try{mt.waitForAll();}
    catch(Exception e){System.err.println(e);}
    
    for (int i=0;i<jcList.size();i++)
      ((JIMMComponent)jcList.elementAt(i)).allImagesLoaded();
  }   
    
    

  public void linkRotatables(JIMMComponent jc) {
    if (jc.rubberBand == null) {  //if not yet connected
      if (!modalTrace) {
        setStatusText(itemList.getSelectedItem() + ": " + RUBBER_BAND_STATUS_2);
        tempRotatable= jc;                
        traceX= jc.getLocation().x+jc.getConnectionPoint().x;
        traceY= jc.getLocation().y+jc.getConnectionPoint().y;
        modalTrace= true;
      } else {        
        setStatusText(DEFAULT_STATUS);
        modalTrace= false;
        //connect them!
        JIMCRubberBand band= (JIMCRubberBand)factory.createJIMMComponent("RubberBand", 0, 0);
        itemList.remove(itemList.getSelectedItem());
        band.connectFirst(tempRotatable);
        band.connectSecond(jc);      
        //reset tempRotatable
        tempRotatable= null;          
      }
    }
  }  
 
  
  /** makes sure that JIMCGearWheels automatically connect to each other if 
    * they are "neighbours"                                                 */
  public void autoLink(JIMMComponent gw) {
    JIMMComponent jc= null;    
    Rectangle r0, r1;     //bounding rectangles of compared JIMMComponents

    r0=new Rectangle(gw.getLocation().x, gw.getLocation().y,
                     gw.getSize().width+3, gw.getSize().height+3);    

    for (int i=0; i<this.mapContainer.getComponentCount(); i++) {
      jc=(JIMMComponent)mapContainer.getComponent(i);

      if ((!jc.equals(gw))&&(jc instanceof JIMCGearWheel)) {
         //create bigger Rectangle to see if GearWheels touch each other
         r1= new Rectangle(jc.getLocation().x, jc.getLocation().y,
                           jc.getSize().width+3, jc.getSize().height+3);              
          
         if (r0.intersects(r1)) {          
           gw.rotateList.add(jc);
         }
       }
    }
  }
  
  
  public void Applet_mouseMoved(java.awt.event.MouseEvent event) {
    if (modalTrace) {              
      mapContainer.repaint();
      Graphics g= mapContainer.getGraphics();    
      g.setColor(Color.red);
      g.drawLine(traceX, traceY, event.getX(), event.getY());
     }
  }
  
  
  public void setStatusText(String statusText) {
    statusLabel.setText(statusText);
  }
  
};

