package psw2.JIM;

import java.applet.*;
import java.awt.*;
import java.awt.image.*;

public class JIMCRubberBand extends JIMMComponent {
  public static JIMPolygon classpoly;
  private JIMMComponent end1, end2;  //JIMMComponents connected with RubberBand
  {
    classpoly= null;
  };

  public JIMCRubberBand() {
    super();

    isMirrorable= false;
    isResizeNS  = false;
    isResizeWE  = false;
    isLocked    = true;
    isFixed     = true;
    
    setSize(new Dimension(55, 55));
  };   
  
  
  public void paint(Graphics g) {
    if (image != null) g.drawImage(image, 0, 0, this);
  };
  
  public void calcRotation() {      
    if ((end1.getRotation() == 0)&&(end2.getRotation() != 0)) {
      end1.setRotation(end2.getRotation());
      this.setRotation(end2.getRotation());
    }else if ((end1.getRotation() != 0)&&(end2.getRotation() == 0)) {
      end2.setRotation(end1.getRotation());
      this.setRotation(end1.getRotation());
    }else if (end1.getRotation() != end2.getRotation()) {
      end1.setBlocked(true);
      end2.setBlocked(true);
      this.setBlocked(true);
    };
  };  
  
  
  public void connectFirst(JIMMComponent end1) {
    this.end1= end1;    
    end1.setRubberBand(this);
  }; 
  
  public void connectSecond(JIMMComponent end2) {
    this.end2= end2;    
    end2.setRubberBand(this);    
    updateImage();
  };
  
  
  public void onRemove()
  {
    if (end1!=null)
    {	end1.rubberBand=null;
    	end1=null;
    }
    if (end2!=null)
    {	end2.rubberBand=null;
    	end2=null;
    }
  }  
  
  
  /** makes image fit to current Location and Dimension of connected JIMComponents */
  public void updateImage() {
    ImageFilter clearBGFilter;        //because we need a transparent
    Color bandColor= Color.darkGray;  //Color of our JIMCRubberBand
    Color maskColor= Color.black;
    
    int widthNew, heightNew;
    int end1X= end1.getLocation().x + end1.getConnectionPoint().x;
    int end1Y= end1.getLocation().y + end1.getConnectionPoint().y;
    int end2X= end2.getLocation().x + end2.getConnectionPoint().x;
    int end2Y= end2.getLocation().y + end2.getConnectionPoint().y;    
    
    //correct Location & Dimension
    this.setLocation(Math.min(end1X, end2X), Math.min(end1Y, end2Y));
                     
    widthNew  = Math.abs(end1X - end2X) != 0 ? Math.abs(end1X - end2X) : 1;
    heightNew = Math.abs(end1Y - end2Y) != 0 ? Math.abs(end1Y - end2Y) : 1;
     
    this.setSize(new Dimension(widthNew+2, heightNew+2));
    
    //create a transparent image and draw into offscreen image    
    image= createImage(widthNew, heightNew);    
    Graphics g= image.getGraphics();   
    g.setColor(Color.white);
    g.fillRect(0, 0, widthNew, heightNew);
    g.setColor(maskColor);
    g.drawLine(end1X <  end2X ? 0 : widthNew, end1Y <  end2Y ? 0 : heightNew, 
               end1X >= end2X ? 0 : widthNew, end1Y >= end2Y ? 0 : heightNew);
    
    clearBGFilter= new JIMColorFilter(maskColor , bandColor);
    image= createImage(new FilteredImageSource(image.getSource(), clearBGFilter));
  };  
  
  
  public void newMachineTurn() {
    calcRotation();
  };

     
  public String toString(){
    String str= super.toString();
    str+="+"+app.jcList.indexOf(end1)+"+"+app.jcList.indexOf(end2);
    return str;
  }

  
  public void fromString(java.util.StringTokenizer args){
    super.fromString(args);
    if (args.hasMoreTokens())
    {	connectFirst((JIMMComponent)app.jcList.elementAt(Integer.parseInt(args.nextToken())));
    	if (args.hasMoreTokens())
    		connectSecond((JIMMComponent)app.jcList.elementAt(Integer.parseInt(args.nextToken())));
    	else
    		app.factory.removeComponent(this);
    }
  }
  
  class JIMColorFilter  extends  RGBImageFilter  {
	  protected static final int rgbMask	= 0x00ffffff;
	  protected static final int alphaMask= 0xff000000;
	  protected static final int cmask	  = 0x00c0c0c0; 
	  protected int from, to;
 
	  public  JIMColorFilter(Color frm, Color t)  {
		  super();
		  from= frm.getRGB() & rgbMask;
		  to  = t.getRGB() & rgbMask;
		  //the filter's operation does not depend on the pixel's location, so 
		  //IndexColorModels can be filtered directly.
		  canFilterIndexColorModel= true;
	  }
	
	  public  int  filterRGB(int x, int y, int rgb)  {
		  return(((rgb & cmask ) != cmask )?(to | (rgb & alphaMask)) : rgbMask );
    }
  }  
}