package psw2.JIM;
import java.applet.*;
import java.awt.*;
import java.awt.image.*;


public class JIMDblBufferedContainer extends Container {
  
  protected Image bufImage;               //image for double-buffering
  protected Graphics bufGraphics;         //graphics-context for double-buffering

  private void init() {	  
	  setLayout(null);
	  if ((getParent() != null)&&(getSize() != null)&&
	      (getSize().width>0) && (getSize().height>0))
	  try {		
	    bufImage=getParent().createImage(getSize().width, getSize().height);
	    bufGraphics=bufImage.getGraphics();
	  } catch(Exception e) {
	    bufImage=null;
	    bufGraphics=null;
	  }	  
  }
  
  
  public void repaint() {
    update(getGraphics());
  }  
  
  
  public void update(Graphics g) {    
    if ((bufGraphics!=null) && (g!=null)) {
    	paint(bufGraphics);
    	g.drawImage(bufImage, 0, 0, this);
    }else 
   	  init();
  }


  public void paint(Graphics g) {
  	int i;
  	JIMMComponent comp;
  	java.util.Vector jcList;
  	Component parent=getParent();
  	Dimension size=getSize();
  	if ((size!=null) && (parent!=null)&&(((JIMApplet)parent).jcList!=null)){
  		jcList=((JIMApplet) parent).jcList;
	
                g.setClip(0,0,size.width,size.height);
		g.clearRect(0,0,size.width,size.height);

	  	int j=jcList.size();
	  	for (i=0;i<j;i++) {
	  	  comp=((JIMMComponent)jcList.elementAt(i));
  		  g.translate(comp.getLocation().x,comp.getLocation().y);
  		  g.setClip(0,0,comp.getSize().width,comp.getSize().height);
  		  comp.paint(g);
  		  g.translate(-comp.getLocation().x,-comp.getLocation().y);
	  	}
	  }
  }
}