package psw2.JIM;

import psw2.JIM.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;


public class JIMEditor extends java.awt.Frame implements WindowListener, ActionListener{
  JIMApplet app;
  java.awt.List itemList;
  java.awt.TextField mapDesc;
  
  final static String SAVEMAPBUTTON = "save map";
  final static String EMPTYMAPBUTTON = "empty map";
  final static String BLANKMAPDESC="This is the place, you can insert the map's Description";
  
  public void windowOpened(WindowEvent e){repaint();}     

  public void windowClosing(WindowEvent e){
    setVisible(false);
    remove(app);
    app.stop();
    app.destroy();
    dispose();
    System.exit(0);
  }

  public void windowClosed(WindowEvent e){
    setVisible(false);
    remove(app);
    app.stop();
    app.destroy();
    dispose();
    System.exit(0);
  }

  public void windowIconified(WindowEvent e){}
  
  public void windowDeiconified(WindowEvent e){repaint();}

  public void windowActivated(WindowEvent e){}

  public void windowDeactivated(WindowEvent e){}

  public void actionPerformed(ActionEvent event){
    String cmd= event.getActionCommand();
    if(cmd.equals(SAVEMAPBUTTON)){
      if (!app.isRunning) saveMap();
    }
    else if(cmd.equals(EMPTYMAPBUTTON)){
      if (!app.isRunning) {
        app.mapContainer.removeAll();
        app.itemList.removeAll();
        app.jcList.removeAllElements();
        app.mapContainer.repaint();
      }
    }
  }
    
  
  void saveMap() {
    try{
      FileDialog fd= new FileDialog(new Frame());
      fd.setMode(FileDialog.SAVE);
      fd.setDirectory("psw2"+File.separator+"JIM"+File.separator+"maps"+File.separator);

      fd.show();
      
      app.mapDesc=mapDesc.getText();
      if (fd.getFile()!=null) {
        FileOutputStream fileOS =new FileOutputStream(fd.getDirectory()+fd.getFile());        
        for (int i=0;i<app.jcList.size();i++)
          ((JIMMComponent)app.jcList.elementAt(i)).isLocked=true;
        app.saveMap(fileOS);
        for (int i=0;i<app.jcList.size();i++)
          ((JIMMComponent)app.jcList.elementAt(i)).isLocked=false;        
        fileOS.close();
      }
    }catch(Exception e){
      System.err.println(e.toString() + " at saveMap: ");      
    }
  }
 
  
  public void init() {
    Button btn;
    Panel buttonPanel = new Panel();
    Panel eastPanel = new Panel();

    addWindowListener(this);
    setBounds(10,10,810,410); 

    app=new JIMWrapperApplet();   

    buttonPanel.setLayout(new GridLayout(2,1));
  
    btn= new Button(SAVEMAPBUTTON);
    btn.addActionListener((ActionListener)this);
    buttonPanel.add(btn);

    btn= new Button(EMPTYMAPBUTTON);
    btn.addActionListener((ActionListener)this);
    buttonPanel.add(btn);
  
    itemList=new java.awt.List();
    itemList.addMouseListener(new MouseAdapter(){
      public void mouseClicked(java.awt.event.MouseEvent event){
        if(itemList.getSelectedItem()!=null) {
          app.itemList.add(itemList.getSelectedItem());
        }
      }
    });
    itemList.setSize(new Dimension(124,316));

    eastPanel.setLayout(new BorderLayout());
    eastPanel.add(buttonPanel, BorderLayout.NORTH);
    eastPanel.add(itemList, BorderLayout.CENTER);
 
    setLayout(new BorderLayout());
    add(eastPanel, BorderLayout.EAST);   
    add(app,BorderLayout.CENTER);
    
    mapDesc=new TextField(BLANKMAPDESC);
    add(mapDesc,BorderLayout.SOUTH);

    setVisible(true);
    setResizable(false);
    app.init();
    app.itemList.addKeyListener(new KeyAdapter(){
      public void keyPressed(KeyEvent e) {
        if ((e.getKeyCode()==KeyEvent.VK_DELETE) && (app.itemList.getSelectedIndex()>=0))
        { 
          int oldidx=app.itemList.getSelectedIndex();
          app.itemList.remove(oldidx);
          app.itemList.select(oldidx);
        }
      }
    });
    app.start();
    app.doLayout();
    initItemList();
  }
 
  
  void initItemList() {
    File dir= new File("psw2"+File.separator+"JIM");
    if(dir.isDirectory()) {
      String[] files= dir.list();
      String curStr= null;

      for(int i=0; i<files.length; i++){
        curStr= files[i];
        //also check for appearing '$' which indicates inner/anonymous classes!
        if(curStr.endsWith(".class") && curStr.startsWith("JIMC") && (!curStr.startsWith("JIMMComponent")) && (curStr.indexOf('$')==-1))
          itemList.add( curStr.substring(4, curStr.length()-6) );
      }
    } else
      System.err.println("directory "+dir.getName()+" does not exist (initItemList)");
  }

  
  public static void main(String[] args) {
    JIMEditor frm=new JIMEditor();
    frm.init();
  }
}

