package psw2.JIM;

import psw2.JIM.*;

public class JIMFactory {
  JIMApplet applet;

  //creates a new Factory
  //applet is the applet to place the created components in
  public JIMFactory(JIMApplet applet)
  {
    this.applet=applet; 
  }
  
  //creates an object of class ClassName, and puts it into the applet at (x,y).
  //if addComp==true then addComp is added
  //afterwards it returns the created object, or returns null, if there
  //was some kind of error
  public JIMMComponent createJIMMComponent(String args, int x, int y)
  {
    return createJIMMComponent(args,x,y,true);
  }
        
  public JIMMComponent createJIMMComponent(String args, int x, int y,boolean sort)
  {
    String ClassName;
    JIMMComponent ret=null;
  
    if(args.indexOf('+')!=-1) {
      ClassName= args.substring(0, args.indexOf('+')); //get JIMC-id
      args=args.substring(args.indexOf('+'), args.length());
    }
    else{
      ClassName= args;
      args=null;
    }

    
    try { 
      ret=(JIMMComponent) Class.forName("psw2.JIM.JIMC"+ClassName).newInstance();
    } catch (Exception e) {
      System.err.println("Couldnt generate "+ClassName+"\n"+e);
      return null;
    };

    //so we've got a proper generated and casted JIMMComponent    
    //now set the Position
    ret.updatePolygon();
    ret.setLocation(x,y);
    ret.addKeyListener(applet.componentkeylistener);    
    ret.fpax= ret.getLocation().x<<4;  //only necessary for Components which
    ret.fpay= ret.getLocation().y<<4;  //are producing components (e.g.:Cannon)

    //now check if JIMMComponent can be put where users wants to...
    //JIMCRubberBands are treated in a special way
    if ((ret instanceof JIMCRubberBand)||(applet.getCollisions(ret)==null)) {          
      //JIMCRubberBands must be add last in lists
      if ((!(ret instanceof JIMCRubberBand)) && (sort)) {
        applet.jcList.insertElementAt(ret, 0);
        applet.mapContainer.add(ret, 0);
      } else {  
        applet.jcList.addElement(ret);      
        applet.mapContainer.add(ret);
      }

      ret.init(applet);
      if(args!=null)
        ret.fromString(new java.util.StringTokenizer(args,"+")); // does additional initialization
      return(ret);
    } else 
      return(null);
  }
  
  
  public void removeComponent(JIMMComponent comp) 
  {
    if (comp!=null)
    {
      applet.jcList.remove(comp);
      comp.onRemove();
      applet.mapContainer.remove(comp);
      if (comp.rubberBand!=null) removeComponent(comp.rubberBand);
      applet.mapContainer.repaint();
      applet.itemList.add(comp.getClass().toString().substring(19, comp.getClass().toString().length()));        
    }
  }

}

