package psw2.JIM;
import java.applet.*;
import java.awt.*;
import java.awt.image.*;
import java.util.*;

public class JIMMComponent extends Component {
  //constants
  protected static final int NO_DRAG= 0;
  protected static final int UP_DRAG= 1;
  protected static final int DN_DRAG= 2;
  protected static final int LE_DRAG= 3;
  protected static final int RI_DRAG= 4;
  protected static final int MV_DRAG= 5;

  //fields
  protected int DRAG_MODE= NO_DRAG;       //default drag-mode is "NO_DRAG"
  protected int dragX;                    //X-coordinate of dragging-origin
  protected int dragY;                    //Y-coordinate of dragging-origin
  protected boolean isLocked;             //JIMMComponent moveable?
  protected boolean isResizeNS;           //JIMMComponent resizable North-South
  protected boolean isResizeWE;           //JIMMComponent resizable West-East
  protected boolean isMirrorable;         //JIMMComponent can be mirrored?
  protected int vx;                       //X-component of speed-vector
  protected int vy;                       //Y-component of speed-vector
  protected int weight=10;
  protected int lift;
  protected int rotation;
  protected boolean blocked= false;
  protected float rebFact=0.9f;           //rebounce-factor
  protected int orientation;              //-1 left, +1 right
  protected boolean drawBounds= false;    //disable drawing of bounding rectangle
  protected int ani= 0;                   //current animation frame

  protected java.util.Vector lightShedderList;
  protected java.util.Vector lightSensorList;
  protected java.util.Vector heatShedderList;
  protected java.util.Vector heatSensorList;
  protected java.util.Vector rotateList;
  protected JIMPolygon poly;                 //stores exact shapes of JIMMComponent
  protected Image image;                     //graphical representation of JIMMComponent
  protected Rectangle minCon;                //JIMMComponents "Mini-Control" for Mirroring
  protected Color boundsColor= Color.blue;
  protected Point connectionPoint= null;     //point where JIMCRubberBand can be attached
	protected JIMMComponent rubberBand= null;
  protected JIMApplet app;

  Image images[];
  public static JIMPolygon classpoly;
  protected int fpax=0, fpay=0;
  protected boolean isFixed;
  public Point oldLocation;

  {
    int xpoints[]=new int[] {0,100,100,0};
    int ypoints[]=new int[] {0,0,100,100};

    classpoly=new JIMPolygon(xpoints,ypoints);
  };

  public JIMMComponent() {
    //{{REGISTER_LISTENERS
    SymMouse aSymMouse = new SymMouse();
    this.addMouseListener(aSymMouse);
    SymMouseMotion aSymMouseMotion = new SymMouseMotion();
    this.addMouseMotionListener(aSymMouseMotion);
    //}}

    setSize(new Dimension(50, 50));
    //create "Mini-Control" for Mirroring
    minCon= new Rectangle(0, 0, 15, 15);

    //JIMMComponent can be mirrored, moved and resized
    isMirrorable= true;
    isLocked= false;
    isResizeNS= true;
    isResizeWE= true;

    lightShedderList=new java.util.Vector();
    lightSensorList=new java.util.Vector();
    heatShedderList=new java.util.Vector();
    heatSensorList=new java.util.Vector();
    rotateList= new java.util.Vector();
  };

  boolean doneimg=false;

  
  //fixed initialisation
  public final void init(JIMApplet app) {
    //save reference to JIMApplet
    this.app= app;

    //load graphical representation of JIMObject
    images= this.app.getImagesForClass(this);
    image= images[0];

    //initially JIMMComponent looks to the right and does not rotate
    orientation= 1;
    rotation= 0;
    
    loadedInit();
  };


  /** Component-specific initialization */
  public void loadedInit() {
  };

  
  public int getRotation() {
    return(this.rotation);
  };


  public void setRotation(int rotation) {
    if (!blocked) this.rotation= rotation;
  };


  public boolean getBlocked() {
    return(this.blocked);
  };


  public void setBlocked(boolean blocked) {
    this.blocked= blocked;
  };


  public JIMMComponent getRubberBand() {
    return(this.rubberBand);
  };


  public void setRubberBand(JIMMComponent rubberBand) {
    this.rubberBand= rubberBand;
  };


  public Point getConnectionPoint() {
    return(this.connectionPoint);
  };


  /** determines an objects rotation-behaviour */
  public void onRotate() {
  };

  
  /** Called after all images have been loaded **/
  public void allImagesLoaded(){
  }

  
  /** determines objects behaviour if a collision occurs */
  public void onCollision(int vertexidx, int jcvertexidx, JIMMComponent jc) {
  };
  
  
  public void repaint(long tm, int x, int y, int width, int height) {
  };

  
  public void update(Graphics g) {
    if (g != null) paint(g);
  };


  public void paint(Graphics g) {
    //draw graphical representation of JIMMComponent
    if (image != null) g.drawImage(image, 0, 0, this);
    if (drawBounds) {     
      g.setColor(boundsColor);
      //draw bounding rectangle of JIMMComponent
      g.drawRect(0, 0, getSize().width-1, getSize().height-1);
    };
  };


  class SymMouse extends java.awt.event.MouseAdapter {
    Point oldpos;
    public void mouseReleased(java.awt.event.MouseEvent event)
    {
      Object object = event.getSource();
      if (object == JIMMComponent.this)
      {
        JIMMComponent_MouseReleased(event);
        int dist=(getLocation().x-oldpos.x)*(getLocation().x-oldpos.x)+(getLocation().y-oldpos.y)*(getLocation().y-oldpos.y);
        if ((dist>0) && (dist<=9)) //snap small drags around original Position to clicks
        { setLocation(oldpos);
          if (rubberBand != null) 
            ((JIMCRubberBand)rubberBand).updateImage();
          
          app.mapContainer.repaint();
          mouseClicked(event);	
        }
      }
    }

    
    public void mousePressed(java.awt.event.MouseEvent event)
    {
      Object object = event.getSource();
      if (object == JIMMComponent.this)
      {
        oldpos=getLocation();
        JIMMComponent_MousePressed(event);
  
      }
    }

    
    public void mouseClicked(java.awt.event.MouseEvent event)
    {
      Object object = event.getSource();
      if (object == JIMMComponent.this)
        JIMMComponent_MouseClicked(event);
    }

    public void mouseExited(java.awt.event.MouseEvent event)
    {
      Object object = event.getSource();
      if (object == JIMMComponent.this)
        JIMMComponent_MouseExited(event);
    }

    public void mouseEntered(java.awt.event.MouseEvent event)
    {
      Object object = event.getSource();
      requestFocus();//so key events are processed by this Component
      if (object == JIMMComponent.this)
        JIMMComponent_MouseEntered(event);
    }
  }


  void JIMMComponent_MouseEntered(java.awt.event.MouseEvent event) {
    if ((!app.isRunning)&&(!isLocked)) {  //if JIMMComponent is not locked
      //enable drawing of bounding rectangle of JIMMComponent
      drawBounds= true;

      if ((isMirrorable)&&(minCon.contains(event.getX(), event.getY())))       
        //mirror control entered  
        this.setCursor(new Cursor(Cursor.HAND_CURSOR));
      else if ((isResizeWE)&&(event.getX() <= 5))
        this.setCursor(new Cursor(Cursor.W_RESIZE_CURSOR));
      else if ((isResizeWE)&&(event.getX() >= getSize().width - 5))
        this.setCursor(new Cursor(Cursor.E_RESIZE_CURSOR));
      else if ((isResizeNS)&&(event.getY() <= 5))
        this.setCursor(new Cursor(Cursor.N_RESIZE_CURSOR));
      else if ((isResizeNS)&&(event.getY() >= getSize().height - 5))
        this.setCursor(new Cursor(Cursor.S_RESIZE_CURSOR));
      else
        this.setCursor(new Cursor(Cursor.MOVE_CURSOR));
      
      app.mapContainer.repaint();
    };
  };


  void JIMMComponent_MouseExited(java.awt.event.MouseEvent event) {
    //disable drawing of bounding rectangle of JIMMComponent
    drawBounds= false;

    this.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));

    app.mapContainer.repaint();
  };


  class SymMouseMotion extends java.awt.event.MouseMotionAdapter
  {
    public void mouseDragged(java.awt.event.MouseEvent event)
    {
      Object object = event.getSource();
      if (object == JIMMComponent.this)
        JIMMComponent_MouseDragged(event);
    }

    public void mouseMoved(java.awt.event.MouseEvent event)
    {
      Object object = event.getSource();
      if (object == JIMMComponent.this)
      {
      	JIMMComponent_MouseEntered(event);
      	//and also notify the applet, that the mouse has been moved (coordinates are tranformed!)
      	app.Applet_mouseMoved(new java.awt.event.MouseEvent(event.getComponent(),event.getID(),event.getWhen(),event.getModifiers(),event.getX()+getLocation().x,event.getY()+getLocation().y,event.getClickCount(),event.isPopupTrigger()));
      }
    }
  }


  void JIMMComponent_MouseClicked(java.awt.event.MouseEvent event) {
    //if "Mini-Control"-clicked
    if (!app.isRunning)
    {
    	if ((isMirrorable)&&(minCon.contains(event.getX(), event.getY()))) {
	      mirror();
	    } else if ((this.connectionPoint != null)&&(app.itemList.getSelectedItem() != null)&&
        	       (app.itemList.getSelectedItem().equals("RubberBand")))  {
	      //Event has to be handled by JIMApplet => JIMRubberBand links JIMMComponents
	      app.linkRotatables(this);	      
	    } else
	      app.tempRotatable= null;
    }
  };


  void JIMMComponent_MouseDragged(java.awt.event.MouseEvent event) {
    //check if JIMMComponent was dragged
    if ((!isLocked)&&(!app.isRunning))
      dragComponent(event);
  };


  void JIMMComponent_MousePressed(java.awt.event.MouseEvent event) {
    //check current cursor for determining correct drag-mode
   if (!app.isRunning){
    switch(this.getCursor().getType()) {

      case Cursor.MOVE_CURSOR:
        DRAG_MODE= MV_DRAG;  //dragging-mode: move-drag
        break;

      case Cursor.N_RESIZE_CURSOR:
        DRAG_MODE= UP_DRAG;  //dragging-mode: up-resize-drag
        break;

      case Cursor.S_RESIZE_CURSOR:
        DRAG_MODE= DN_DRAG;  //dragging-mode: down-resize-drag
        break;

      case Cursor.W_RESIZE_CURSOR:
        DRAG_MODE= LE_DRAG;  //dragging-mode: left-resize-drag
        break;

      case Cursor.E_RESIZE_CURSOR:
        DRAG_MODE= RI_DRAG;  //dragging-mode: right-resize-drag
        break;

      default:
        DRAG_MODE= NO_DRAG;
        break;
    };
    //get dragging-origin-coords
    dragX= event.getX();
    dragY= event.getY();
   }
  };


  void JIMMComponent_MouseReleased(java.awt.event.MouseEvent event) {
    //check if JIMMComponent was dragged
    if ((!isLocked)&&(!app.isRunning))
	    dragComponent(event);
  };


  /** does dragging and resizing operations on JIMMComponent */
  protected void dragComponent(java.awt.event.MouseEvent event) {
    boolean polyChanged= false;
    //save current location and size
    Point oldLocation= this.getLocation();
    Dimension oldSize= this.getSize();

    switch(DRAG_MODE) {

      case MV_DRAG:  //JIMMComponent was moved
        setLocation(getLocation().x + event.getX() - dragX,
                    getLocation().y + event.getY() - dragY);
        break;

      case UP_DRAG:  //JIMMComponent was resized at upper-bound
        setBounds(getLocation().x,
                  getLocation().y + event.getY() - dragY,
                  getSize().width,
                  getSize().height + dragY - event.getY());
        polyChanged= true;  //JIMPolygon needs to be updated
        break;

      case DN_DRAG:  //JIMMComponent was resized at lower-bound
        setSize(getSize().width, event.getY());
        polyChanged= true;  //JIMPolygon needs to be updated
        break;

      case LE_DRAG:  //JIMMComponent was resized at left-bound
        setBounds(getLocation().x + event.getX() - dragX,
                  getLocation().y,
                  getSize().width + dragX - event.getX(),
                  getSize().height);
        polyChanged= true;  //JIMPolygon needs to be updated
        break;

      case RI_DRAG:  //JIMMComponent was resized at right-bound
        setSize(event.getX(), getSize().height);
        polyChanged= true;  //JIMPolygon needs to be updated
        break;

      default:
        break;
    };
    //if JIMMComponent cannot be put restore old valid state
    
    fpax=(getLocation().x<<4);
    fpay=(getLocation().y<<4);

    if (app.getCollisions(this)!=null) {
      this.setLocation(oldLocation);
      this.setSize(oldSize);      
    }
    else if (polyChanged) updatePolygon();
	
    //if JIMCRubberBand is connected to JIMComponent, it also needs an update
    if (rubberBand != null) 
     ((JIMCRubberBand)rubberBand).updateImage();
    
    //enable drawing of bounding rectangle
    drawBounds= true;

    //draw graphical representation of JIMMComponent
    if (getParent()!=null) getParent().repaint();
  };


  public void fpamoveto(int fpax, int fpay) {
    if (isFixed) {
      vx=0;
      vy=0;
    }else{
      this.fpax=fpax;
      this.fpay=fpay;
    };
  };


  public void fpamove() {
    fpamoveto(fpax+vx,fpay+vy);
  };


  public void newMachineTurn() {}


  public void startMachine() {}
  

  public void updatePolygon() {
    try {
      Object obj=getClass().getField("classpoly").get(this);
      poly=(obj==null)?null:new JIMPolygon((JIMPolygon)obj);
    } catch (Exception e) {
      //this acually cannot happen, but no one knows
      System.err.println("Could access field classpoly, using default ...");
      poly=null;
    };
    if (poly!=null)
    {
    	if (orientation==-1) poly.mirror(getSize().width/2);
    	poly.setSize(getSize().width,getSize().height);
    }
  };


  /** mirrors JIMMComponent */
  public void mirror() {
    //JIMMComponent is mirrored => direction is reverted
    orientation*= -1;

    //swap images
    if (orientation == 1)
      this.image= images[0];
    else
      this.image= images[1];
    updatePolygon();
    for (int i=0;i<lightShedderList.size();i++)
    {
      ((JIMPolygon)lightShedderList.elementAt(i)).mirror(getSize().width/2);
    }    
    for (int i=0;i<heatShedderList.size();i++)
    {
      ((JIMPolygon)heatShedderList.elementAt(i)).mirror(getSize().width/2);
    }
    for (int i=0;i<lightSensorList.size();i++)
    {
      JIMPropertyPoint ppt=((JIMPropertyPoint)lightSensorList.elementAt(i));
      ppt.x+=getSize().width-2*ppt.x;
    }    
    for (int i=0;i<heatSensorList.size();i++)
    {
      JIMPropertyPoint ppt=((JIMPropertyPoint)heatSensorList.elementAt(i));
      ppt.x+=getSize().width-2*ppt.x;
    }        

    if (connectionPoint != null) {
      connectionPoint.x= this.getSize().width - connectionPoint.x;                  
      
      //if JIMCRubberBand is connected to JIMComponent, it also needs an update
      if (rubberBand != null) 
        ((JIMCRubberBand)rubberBand).updateImage();
    }
    
    getParent().repaint();
  };
  
  
  public void onRemove() {}  
  
  public String toString() {
    String str=super.toString();
    //first param: JIMComponent-id -> every JIMC has one
    str=str.substring(13, str.indexOf("["))+"+"+(isLocked?1:0);  
    if (isMirrorable) str+="+"+orientation;  
    if (isResizeWE) str+="+"+getSize().width;  
    if (isResizeNS) str+="+"+getSize().height;  
    return str;
  }

  
  public void fromString(java.util.StringTokenizer args){
    if ((args.hasMoreTokens()) && (args.nextToken().equals("1"))) isLocked=true;    
    if ((args.hasMoreTokens()) && (isMirrorable) && (Integer.parseInt(args.nextToken())!=1)) mirror();
    if ((args.hasMoreTokens()) && (isResizeWE)) {setSize(Integer.parseInt(args.nextToken()),getSize().height);updatePolygon();} 
    if ((args.hasMoreTokens()) && (isResizeNS)) {setSize(getSize().width,Integer.parseInt(args.nextToken()));updatePolygon();}    
  }
};